//  
//   Rebex Sample Code License
// 
//   Copyright 2024, REBEX CR s.r.o.
//   All rights reserved.
//   https://www.rebex.net/
// 
//   Permission to use, copy, modify, and/or distribute this software for any
//   purpose with or without fee is hereby granted.
// 
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
//   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
//   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
//   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
//   OTHER DEALINGS IN THE SOFTWARE.
// 

using Rebex.TerminalEmulation;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Windows.Forms;

namespace Rebex.Samples.Scripts
{
    [Description("02: Detecting prompt")]
    public class DetectPrompt
    {
        public static void Execute(Scripting scripting)
        {
            // detect remote shell's prompt
            scripting.DetectPrompt();

            // display detected prompt
            MessageBox.Show("Prompt: " + scripting.Prompt);

            // send 'whoami' command to detect my user name
            scripting.SendCommand("whoami");

            // read response
            string userName = scripting.ReadUntilPrompt();

            // show message
            string message = "User name: " + userName + "\n";
            MessageBox.Show(message);

            // end of script
        }

    }
}
