'  
'   Rebex Sample Code License
' 
'   Copyright 2024, REBEX CR s.r.o.
'   All rights reserved.
'   https://www.rebex.net/
' 
'   Permission to use, copy, modify, and/or distribute this software for any
'   purpose with or without fee is hereby granted.
' 
'   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'   OTHER DEALINGS IN THE SOFTWARE.
' 

Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms

''' <summary>
''' make dir dialog
''' </summary>
Public Class MakeDir
    Inherits System.Windows.Forms.Form
    Private tbDir As System.Windows.Forms.TextBox
    Private btnOK As System.Windows.Forms.Button
    Private btnCancel As System.Windows.Forms.Button
    Private components As System.ComponentModel.Container = Nothing

    Private m_strDirectory As String = Nothing ' directory name

    <Browsable(False)>
    <DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
    Public Property Directory() As String
        Get
            Return m_strDirectory
        End Get
        Set
            m_strDirectory = value
        End Set
    End Property

    Public Sub New()
        InitializeComponent()
    End Sub

    ' -------------------------------------------------------------------------
    ''' <summary>
    ''' clean up any resources being used
    ''' </summary>
    Protected Overrides Sub Dispose(disposing As Boolean)
        If disposing Then
            If components IsNot Nothing Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    #Region "Windows Form Designer generated code"
    ''' <summary>
    ''' Required method for Designer support - do not modify
    ''' the contents of this method with the code editor.
    ''' </summary>
    Private Sub InitializeComponent()
        Me.tbDir = New System.Windows.Forms.TextBox()
        Me.btnOK = New System.Windows.Forms.Button()
        Me.btnCancel = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        ' 
        ' tbDir
        ' 
        Me.tbDir.Location = New System.Drawing.Point(16, 16)
        Me.tbDir.Name = "tbDir"
        Me.tbDir.Size = New System.Drawing.Size(176, 20)
        Me.tbDir.TabIndex = 0
        Me.tbDir.Text = ""
        ' 
        ' btnOK
        ' 
        Me.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnOK.Location = New System.Drawing.Point(200, 16)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.TabIndex = 1
        Me.btnOK.Text = "OK"
        AddHandler Me.btnOK.Click, New System.EventHandler(AddressOf Me.btnOK_Click)
        ' 
        ' btnCancel
        ' 
        Me.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnCancel.Location = New System.Drawing.Point(280, 16)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.TabIndex = 2
        Me.btnCancel.Text = "Cancel"
        AddHandler Me.btnCancel.Click, New System.EventHandler(AddressOf Me.btnCancel_Click)
        ' 
        ' MakeDir
        ' 
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(368, 56)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnCancel, Me.btnOK, Me.tbDir})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.MinimizeBox = False
        Me.MaximizeBox = False
        Me.ShowInTaskbar = False
        Me.KeyPreview = True
        Me.Name = "MakeDir"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Create folder"
        AddHandler Me.KeyPress, New System.Windows.Forms.KeyPressEventHandler(AddressOf Me.MakeDir_KeyPress)
        Me.ResumeLayout(False)

    End Sub
    #End Region

    ' -------------------------------------------------------------------------
    ''' <summary>
    ''' form confirmation by clicking 'ok' button
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub btnOK_Click(sender As Object, e As System.EventArgs)
        m_strDirectory = tbDir.Text
        Me.Close()
    End Sub

    ' -------------------------------------------------------------------------
    ''' <summary>
    ''' form cancellation
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub btnCancel_Click(sender As Object, e As System.EventArgs)
        Me.Close()
    End Sub

    ' -------------------------------------------------------------------------
    ''' <summary>
    ''' global key handler
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub MakeDir_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs)
        ' when 'enter' is pressed the form is cinfirmed

        If e.KeyChar = ControlChars.Cr Then
            m_strDirectory = tbDir.Text
            Me.Close()
        End If

        ' when 'esc' is pressed the form is closed

        If (e.KeyChar) = Convert.ToChar(Keys.Escape) Then
            Me.Close()
        End If
    End Sub
End Class
