//  
//   Rebex Sample Code License
// 
//   Copyright 2024, REBEX CR s.r.o.
//   All rights reserved.
//   https://www.rebex.net/
// 
//   Permission to use, copy, modify, and/or distribute this software for any
//   purpose with or without fee is hereby granted.
// 
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
//   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
//   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
//   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
//   OTHER DEALINGS IN THE SOFTWARE.
// 

using System.ComponentModel;
using System.Windows.Forms;
using Rebex.TerminalEmulation;

namespace Rebex.Samples.Scripts
{
    [Description("05: Close connection")]
    public class CloseConnection
    {
        public static void Execute(Scripting scripting)
        {
            // send an 'exit' command
            scripting.SendCommand("exit");

            // receive data until the connection is closed.
            string exitResponse = scripting.ReadUntil(ScriptEvent.Closed);

            // show exit message
            MessageBox.Show(exitResponse);

            // end of script
        }
    }
}
