//  
//   Rebex Sample Code License
// 
//   Copyright 2024, REBEX CR s.r.o.
//   All rights reserved.
//   https://www.rebex.net/
// 
//   Permission to use, copy, modify, and/or distribute this software for any
//   purpose with or without fee is hereby granted.
// 
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
//   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
//   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
//   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
//   OTHER DEALINGS IN THE SOFTWARE.
// 

using Rebex.TerminalEmulation;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Windows.Forms;

namespace Rebex.Samples.Scripts
{
    [Description("04: Matching events")]
    public class MatchingEvents
    {
        public static void Execute(Scripting scripting)
        {
            // detect remote shell's prompt
            scripting.DetectPrompt();

            // send 'ls -l' command to display a list of files and directories
            scripting.SendCommand("ls -l");

            // process the response line-by-line until the prompt is encountered
            
            int lines = 0;
            ScriptMatch match;
            do
            {
                match = scripting.WaitFor(ScriptEvent.Line | ScriptEvent.Prompt);

                if (!match.IsPrompt)
                {
                    // process the line
                    //Process(line);
                }

                string line = scripting.ReceivedData;
                lines++;
                
                
            } while (!match.IsPrompt);

            MessageBox.Show("Received " + lines + " lines.");

            // end of script
        }

    }
}
