//  
//   Rebex Sample Code License
// 
//   Copyright 2024, REBEX CR s.r.o.
//   All rights reserved.
//   https://www.rebex.net/
// 
//   Permission to use, copy, modify, and/or distribute this software for any
//   purpose with or without fee is hereby granted.
// 
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
//   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
//   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
//   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
//   OTHER DEALINGS IN THE SOFTWARE.
// 

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Rebex.Samples
{
    partial class MailEditor
    {
        protected System.Windows.Forms.MenuStrip mainMenu;
        protected System.Windows.Forms.ToolStripMenuItem menuItemFile;
        protected System.Windows.Forms.ToolStripMenuItem menuItemNewMessage;
        protected System.Windows.Forms.ToolStripMenuItem menuItemSaveAs;
        protected System.Windows.Forms.ToolStripMenuItem menuItemSaveAttachment;
        protected System.Windows.Forms.ToolStripMenuItem menuItemClose;
        protected System.Windows.Forms.ToolStripMenuItem menuItemInsert;
        protected System.Windows.Forms.ToolStripMenuItem menuItemFileAttachment;
        protected System.Windows.Forms.ToolStripMenuItem menuItemOpenMessage;
        protected System.Windows.Forms.ToolStripSeparator menuItemSeparator;
        protected System.Windows.Forms.OpenFileDialog openFileDialogMessage;
        protected System.Windows.Forms.SaveFileDialog saveFileDialogMessage;
        protected System.Windows.Forms.OpenFileDialog openFileDialogAttachment;
        protected System.Windows.Forms.SaveFileDialog saveFileDialogAttachment;
        protected System.Windows.Forms.TextBox txtFrom;
        protected System.Windows.Forms.Label lblFrom;
        protected System.Windows.Forms.ListBox listBoxAttachments;
        protected System.Windows.Forms.Label lblAttach;
        protected System.Windows.Forms.TextBox txtSubject;
        protected System.Windows.Forms.Label lblSubject;
        protected System.Windows.Forms.TextBox txtCc;
        protected System.Windows.Forms.TextBox txtTo;
        protected System.Windows.Forms.Label lblCc;
        protected System.Windows.Forms.Label lblTo;
        protected System.Windows.Forms.ContextMenuStrip contextMenuAttach;
        protected System.Windows.Forms.ToolStripMenuItem menuItemDelete;
        protected ToolStripMenuItem saveToolStripMenuItem;
        protected FolderBrowserDialog folderBrowserDialog;
        private IContainer components;

        /// <summary>
        /// Cleans up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.mainMenu = new System.Windows.Forms.MenuStrip();
            this.menuItemFile = new System.Windows.Forms.ToolStripMenuItem();
            this.menuItemNewMessage = new System.Windows.Forms.ToolStripMenuItem();
            this.menuItemOpenMessage = new System.Windows.Forms.ToolStripMenuItem();
            this.saveToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.menuItemSaveAs = new System.Windows.Forms.ToolStripMenuItem();
            this.menuItemSaveAttachment = new System.Windows.Forms.ToolStripMenuItem();
            this.menuItemSeparator = new System.Windows.Forms.ToolStripSeparator();
            this.menuItemClose = new System.Windows.Forms.ToolStripMenuItem();
            this.menuItemInsert = new System.Windows.Forms.ToolStripMenuItem();
            this.menuItemFileAttachment = new System.Windows.Forms.ToolStripMenuItem();
            this.openFileDialogMessage = new System.Windows.Forms.OpenFileDialog();
            this.saveFileDialogMessage = new System.Windows.Forms.SaveFileDialog();
            this.openFileDialogAttachment = new System.Windows.Forms.OpenFileDialog();
            this.saveFileDialogAttachment = new System.Windows.Forms.SaveFileDialog();
            this.txtFrom = new System.Windows.Forms.TextBox();
            this.lblFrom = new System.Windows.Forms.Label();
            this.listBoxAttachments = new System.Windows.Forms.ListBox();
            this.contextMenuAttach = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.menuItemDelete = new System.Windows.Forms.ToolStripMenuItem();
            this.lblAttach = new System.Windows.Forms.Label();
            this.txtSubject = new System.Windows.Forms.TextBox();
            this.lblSubject = new System.Windows.Forms.Label();
            this.txtCc = new System.Windows.Forms.TextBox();
            this.txtTo = new System.Windows.Forms.TextBox();
            this.lblCc = new System.Windows.Forms.Label();
            this.lblTo = new System.Windows.Forms.Label();
            this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
            this.txtBody = new System.Windows.Forms.TextBox();
            this.mainMenu.SuspendLayout();
            this.contextMenuAttach.SuspendLayout();
            this.SuspendLayout();
            // 
            // mainMenu
            // 
            this.mainMenu.ImageScalingSize = new System.Drawing.Size(20, 20);
            this.mainMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.menuItemFile,
            this.menuItemInsert});
            this.mainMenu.Location = new System.Drawing.Point(0, 0);
            this.mainMenu.Name = "mainMenu";
            this.mainMenu.Size = new System.Drawing.Size(760, 24);
            this.mainMenu.TabIndex = 22;
            // 
            // menuItemFile
            // 
            this.menuItemFile.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.menuItemNewMessage,
            this.menuItemOpenMessage,
            this.saveToolStripMenuItem,
            this.menuItemSaveAs,
            this.menuItemSaveAttachment,
            this.menuItemSeparator,
            this.menuItemClose});
            this.menuItemFile.MergeIndex = 0;
            this.menuItemFile.Name = "menuItemFile";
            this.menuItemFile.Size = new System.Drawing.Size(37, 20);
            this.menuItemFile.Text = "&File";
            // 
            // menuItemNewMessage
            // 
            this.menuItemNewMessage.MergeIndex = 0;
            this.menuItemNewMessage.Name = "menuItemNewMessage";
            this.menuItemNewMessage.ShortcutKeys = ((System.Windows.Forms.Keys)((System.Windows.Forms.Keys.Control | System.Windows.Forms.Keys.N)));
            this.menuItemNewMessage.Size = new System.Drawing.Size(250, 22);
            this.menuItemNewMessage.Text = "&New message";
            this.menuItemNewMessage.Click += new System.EventHandler(this.menuItemNewMessage_Click);
            // 
            // menuItemOpenMessage
            // 
            this.menuItemOpenMessage.MergeIndex = 1;
            this.menuItemOpenMessage.Name = "menuItemOpenMessage";
            this.menuItemOpenMessage.ShortcutKeys = ((System.Windows.Forms.Keys)((System.Windows.Forms.Keys.Control | System.Windows.Forms.Keys.O)));
            this.menuItemOpenMessage.Size = new System.Drawing.Size(250, 22);
            this.menuItemOpenMessage.Text = "&Open message...";
            this.menuItemOpenMessage.Click += new System.EventHandler(this.menuItemOpenMessage_Click);
            // 
            // saveToolStripMenuItem
            // 
            this.saveToolStripMenuItem.Name = "saveToolStripMenuItem";
            this.saveToolStripMenuItem.ShortcutKeys = ((System.Windows.Forms.Keys)((System.Windows.Forms.Keys.Control | System.Windows.Forms.Keys.S)));
            this.saveToolStripMenuItem.Size = new System.Drawing.Size(250, 22);
            this.saveToolStripMenuItem.Text = "&Save";
            this.saveToolStripMenuItem.Click += new System.EventHandler(this.menuItemSave_Click);
            // 
            // menuItemSaveAs
            // 
            this.menuItemSaveAs.MergeIndex = 3;
            this.menuItemSaveAs.Name = "menuItemSaveAs";
            this.menuItemSaveAs.ShortcutKeys = ((System.Windows.Forms.Keys)(((System.Windows.Forms.Keys.Control | System.Windows.Forms.Keys.Shift) 
            | System.Windows.Forms.Keys.S)));
            this.menuItemSaveAs.Size = new System.Drawing.Size(250, 22);
            this.menuItemSaveAs.Text = "Sa&ve as...";
            this.menuItemSaveAs.Click += new System.EventHandler(this.menuItemSaveAs_Click);
            // 
            // menuItemSaveAttachment
            // 
            this.menuItemSaveAttachment.MergeIndex = 4;
            this.menuItemSaveAttachment.Name = "menuItemSaveAttachment";
            this.menuItemSaveAttachment.ShortcutKeys = ((System.Windows.Forms.Keys)(((System.Windows.Forms.Keys.Control | System.Windows.Forms.Keys.Shift) 
            | System.Windows.Forms.Keys.A)));
            this.menuItemSaveAttachment.Size = new System.Drawing.Size(250, 22);
            this.menuItemSaveAttachment.Text = "Save &attachments...";
            this.menuItemSaveAttachment.Click += new System.EventHandler(this.menuItemSaveAttachments_Click);
            // 
            // menuItemSeparator
            // 
            this.menuItemSeparator.MergeIndex = 5;
            this.menuItemSeparator.Name = "menuItemSeparator";
            this.menuItemSeparator.Size = new System.Drawing.Size(247, 6);
            // 
            // menuItemClose
            // 
            this.menuItemClose.MergeIndex = 6;
            this.menuItemClose.Name = "menuItemClose";
            this.menuItemClose.ShortcutKeys = ((System.Windows.Forms.Keys)((System.Windows.Forms.Keys.Alt | System.Windows.Forms.Keys.F4)));
            this.menuItemClose.Size = new System.Drawing.Size(250, 22);
            this.menuItemClose.Text = "&Close";
            this.menuItemClose.Click += new System.EventHandler(this.menuItemClose_Click);
            // 
            // menuItemInsert
            // 
            this.menuItemInsert.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.menuItemFileAttachment});
            this.menuItemInsert.MergeIndex = 2;
            this.menuItemInsert.Name = "menuItemInsert";
            this.menuItemInsert.Size = new System.Drawing.Size(48, 20);
            this.menuItemInsert.Text = "&Insert";
            // 
            // menuItemFileAttachment
            // 
            this.menuItemFileAttachment.MergeIndex = 0;
            this.menuItemFileAttachment.Name = "menuItemFileAttachment";
            this.menuItemFileAttachment.Size = new System.Drawing.Size(146, 22);
            this.menuItemFileAttachment.Text = "&Attachment...";
            this.menuItemFileAttachment.Click += new System.EventHandler(this.menuItemFileAttachment_Click);
            // 
            // openFileDialogMessage
            // 
            this.openFileDialogMessage.Filter = "Outlook mails (*.msg)|*.msg|All files (*.*)|*.*";
            // 
            // saveFileDialogMessage
            // 
            this.saveFileDialogMessage.Filter = "Outlook mails (*.msg)|*.msg|All files (*.*)|*.*";
            // 
            // openFileDialogAttachment
            // 
            this.openFileDialogAttachment.Filter = "All files (*.*)|*.*";
            // 
            // saveFileDialogAttachment
            // 
            this.saveFileDialogAttachment.Filter = "All files (*.*)|*.*";
            // 
            // txtFrom
            // 
            this.txtFrom.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.txtFrom.Location = new System.Drawing.Point(88, 35);
            this.txtFrom.Name = "txtFrom";
            this.txtFrom.Size = new System.Drawing.Size(664, 20);
            this.txtFrom.TabIndex = 1;
            this.txtFrom.TextChanged += new System.EventHandler(this.txtFrom_TextChanged);
            // 
            // lblFrom
            // 
            this.lblFrom.Location = new System.Drawing.Point(0, 35);
            this.lblFrom.Name = "lblFrom";
            this.lblFrom.Size = new System.Drawing.Size(80, 16);
            this.lblFrom.TabIndex = 19;
            this.lblFrom.Text = "From:";
            this.lblFrom.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // listBoxAttachments
            // 
            this.listBoxAttachments.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.listBoxAttachments.ContextMenuStrip = this.contextMenuAttach;
            this.listBoxAttachments.Location = new System.Drawing.Point(88, 131);
            this.listBoxAttachments.MultiColumn = true;
            this.listBoxAttachments.Name = "listBoxAttachments";
            this.listBoxAttachments.Size = new System.Drawing.Size(664, 56);
            this.listBoxAttachments.TabIndex = 18;
            // 
            // contextMenuAttach
            // 
            this.contextMenuAttach.ImageScalingSize = new System.Drawing.Size(20, 20);
            this.contextMenuAttach.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.menuItemDelete});
            this.contextMenuAttach.Name = "contextMenuAttach";
            this.contextMenuAttach.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
            this.contextMenuAttach.Size = new System.Drawing.Size(108, 26);
            // 
            // menuItemDelete
            // 
            this.menuItemDelete.MergeIndex = 0;
            this.menuItemDelete.Name = "menuItemDelete";
            this.menuItemDelete.Size = new System.Drawing.Size(107, 22);
            this.menuItemDelete.Text = "Delete";
            this.menuItemDelete.Click += new System.EventHandler(this.menuItemDelete_Click);
            // 
            // lblAttach
            // 
            this.lblAttach.Location = new System.Drawing.Point(0, 131);
            this.lblAttach.Name = "lblAttach";
            this.lblAttach.Size = new System.Drawing.Size(80, 16);
            this.lblAttach.TabIndex = 17;
            this.lblAttach.Text = "Attachments:";
            this.lblAttach.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtSubject
            // 
            this.txtSubject.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.txtSubject.Location = new System.Drawing.Point(88, 107);
            this.txtSubject.Name = "txtSubject";
            this.txtSubject.Size = new System.Drawing.Size(664, 20);
            this.txtSubject.TabIndex = 16;
            this.txtSubject.TextChanged += new System.EventHandler(this.txtSubject_TextChanged);
            // 
            // lblSubject
            // 
            this.lblSubject.Location = new System.Drawing.Point(0, 107);
            this.lblSubject.Name = "lblSubject";
            this.lblSubject.Size = new System.Drawing.Size(80, 16);
            this.lblSubject.TabIndex = 15;
            this.lblSubject.Text = "Subject:";
            this.lblSubject.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtCc
            // 
            this.txtCc.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.txtCc.Location = new System.Drawing.Point(88, 83);
            this.txtCc.Name = "txtCc";
            this.txtCc.Size = new System.Drawing.Size(664, 20);
            this.txtCc.TabIndex = 5;
            this.txtCc.TextChanged += new System.EventHandler(this.txtCc_TextChanged);
            // 
            // txtTo
            // 
            this.txtTo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.txtTo.Location = new System.Drawing.Point(88, 59);
            this.txtTo.Name = "txtTo";
            this.txtTo.Size = new System.Drawing.Size(664, 20);
            this.txtTo.TabIndex = 3;
            this.txtTo.TextChanged += new System.EventHandler(this.txtTo_TextChanged);
            // 
            // lblCc
            // 
            this.lblCc.Location = new System.Drawing.Point(0, 83);
            this.lblCc.Name = "lblCc";
            this.lblCc.Size = new System.Drawing.Size(80, 16);
            this.lblCc.TabIndex = 12;
            this.lblCc.Text = "Cc:";
            this.lblCc.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lblTo
            // 
            this.lblTo.Location = new System.Drawing.Point(0, 59);
            this.lblTo.Name = "lblTo";
            this.lblTo.Size = new System.Drawing.Size(80, 16);
            this.lblTo.TabIndex = 11;
            this.lblTo.Text = "To:";
            this.lblTo.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtBody
            // 
            this.txtBody.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.txtBody.Location = new System.Drawing.Point(3, 193);
            this.txtBody.Multiline = true;
            this.txtBody.Name = "txtBody";
            this.txtBody.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.txtBody.Size = new System.Drawing.Size(749, 222);
            this.txtBody.TabIndex = 23;
            this.txtBody.TextChanged += new System.EventHandler(this.txtBody_TextChanged);
            // 
            // MailEditor
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(760, 417);
            this.Controls.Add(this.txtBody);
            this.Controls.Add(this.txtFrom);
            this.Controls.Add(this.txtSubject);
            this.Controls.Add(this.txtCc);
            this.Controls.Add(this.txtTo);
            this.Controls.Add(this.lblFrom);
            this.Controls.Add(this.listBoxAttachments);
            this.Controls.Add(this.lblAttach);
            this.Controls.Add(this.lblSubject);
            this.Controls.Add(this.lblCc);
            this.Controls.Add(this.lblTo);
            this.Controls.Add(this.mainMenu);
            this.MainMenuStrip = this.mainMenu;
            this.Name = "MailEditor";
            this.Text = "MSG Mail Message Editor";
            this.mainMenu.ResumeLayout(false);
            this.mainMenu.PerformLayout();
            this.contextMenuAttach.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        private TextBox txtBody;
    }
}
