//  
//   Rebex Sample Code License
// 
//   Copyright 2024, REBEX CR s.r.o.
//   All rights reserved.
//   https://www.rebex.net/
// 
//   Permission to use, copy, modify, and/or distribute this software for any
//   purpose with or without fee is hereby granted.
// 
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
//   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
//   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
//   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
//   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
//   OTHER DEALINGS IN THE SOFTWARE.
// 

using System;

namespace Rebex.Samples
{
    /// <summary>
    /// Represents a generic HTTP exception.
    /// </summary>
    public class HttpException : Exception
    {
        public HttpException(int httpStatusCode, string httpMessage)
        {
            HttpStatusCode = httpStatusCode;
            HttpMessage = httpMessage;
        }

        public int HttpStatusCode
        {
            get;
        }

        public string HttpMessage
        {
            get;
        }

        public override string ToString()
        {
            return $"{base.ToString()}, HttpMessage: {HttpMessage}, HttpStatusCode: {HttpStatusCode}";
        }
    }
}
